# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`fwknop`](#fwknop): fwknop  Install fwknop and manage its 2 config files.

#### Private Classes

* `fwknop::config`: This class manages fwknopd.conf and the concat resource for
access.conf.
* `fwknop::install`: This class manages the package resource for fwknop-server.
* `fwknop::service`: This class manages the service resource for fwknop-server.

### Defined types

* [`fwknop::access`](#fwknop--access): fwknop::access  Add a stanza to fwknop's access.conf file.

## Classes

### <a name="fwknop"></a>`fwknop`

fwknop

Install fwknop and manage its 2 config files.

#### Examples

##### 

```puppet
include fwknop
```

#### Parameters

The following parameters are available in the `fwknop` class:

* [`pcap_intf`](#-fwknop--pcap_intf)
* [`enable_pcap_promisc`](#-fwknop--enable_pcap_promisc)
* [`pcap_filter`](#-fwknop--pcap_filter)
* [`enable_spa_packet_aging`](#-fwknop--enable_spa_packet_aging)
* [`max_spa_packet_age_seconds`](#-fwknop--max_spa_packet_age_seconds)
* [`enable_digest_persistence`](#-fwknop--enable_digest_persistence)
* [`rules_check_threshold`](#-fwknop--rules_check_threshold)
* [`enable_ipt_forwarding`](#-fwknop--enable_ipt_forwarding)
* [`enable_ipt_local_nat`](#-fwknop--enable_ipt_local_nat)
* [`enable_ipt_snat`](#-fwknop--enable_ipt_snat)
* [`snat_translate_ip`](#-fwknop--snat_translate_ip)
* [`enable_ipt_output`](#-fwknop--enable_ipt_output)
* [`max_sniff_bytes`](#-fwknop--max_sniff_bytes)
* [`flush_ipt_at_init`](#-fwknop--flush_ipt_at_init)
* [`flush_ipt_at_exit`](#-fwknop--flush_ipt_at_exit)
* [`exit_at_intf_down`](#-fwknop--exit_at_intf_down)
* [`enable_rule_prepend`](#-fwknop--enable_rule_prepend)
* [`enable_nat_dns`](#-fwknop--enable_nat_dns)
* [`gpg_home_dir`](#-fwknop--gpg_home_dir)
* [`gpg_exe`](#-fwknop--gpg_exe)
* [`locale`](#-fwknop--locale)
* [`enable_spa_over_http`](#-fwknop--enable_spa_over_http)
* [`enable_x_forwarded_for`](#-fwknop--enable_x_forwarded_for)
* [`enable_tcp_server`](#-fwknop--enable_tcp_server)
* [`tcpserv_port`](#-fwknop--tcpserv_port)
* [`enable_udp_server`](#-fwknop--enable_udp_server)
* [`udpserv_port`](#-fwknop--udpserv_port)
* [`pcap_dispatch_count`](#-fwknop--pcap_dispatch_count)
* [`pcap_loop_sleep_microseconds`](#-fwknop--pcap_loop_sleep_microseconds)
* [`enable_pcap_any_direction`](#-fwknop--enable_pcap_any_direction)
* [`syslog_identity`](#-fwknop--syslog_identity)
* [`syslog_facility`](#-fwknop--syslog_facility)
* [`enable_destination_rule`](#-fwknop--enable_destination_rule)
* [`fwknop_run_dir`](#-fwknop--fwknop_run_dir)
* [`verbose`](#-fwknop--verbose)
* [`package_manage`](#-fwknop--package_manage)
* [`service_manage`](#-fwknop--service_manage)

##### <a name="-fwknop--pcap_intf"></a>`pcap_intf`

Data type: `Optional[String]`

Define the ethernet interface on which we will sniff packets.
Default if not set is the networking.primary fact.

Default value: `undef`

##### <a name="-fwknop--enable_pcap_promisc"></a>`enable_pcap_promisc`

Data type: `Optional[Boolean]`

If true, put the pcap interface into promiscuous mode. If false,
don't. The man page for fwknopd says this is default enabled, but
the debian config file says it's default disabled. Good luck.

Default value: `undef`

##### <a name="-fwknop--pcap_filter"></a>`pcap_filter`

Data type: `Optional[Variant[Sensitive[String], String]]`

Define the filter used for PCAP modes; we default to udp port 62201.
However, if an fwknop client uses the --rand-port option to send the
SPA packet over a random port, then this parameter should be updated
to something like "udp dst portrange 10000-65535;".
Default is "udp port 62201".

Default value: `undef`

##### <a name="-fwknop--enable_spa_packet_aging"></a>`enable_spa_packet_aging`

Data type: `Optional[Boolean]`

This instructs fwknopd to not honor SPA packets that have an old
time stamp. The value for "old" is defined by the max_spa_packet_age
parameter. If enable_spa_packet_aging is set to false, fwknopd will
not use the client time stamp at all.

Default value: `undef`

##### <a name="-fwknop--max_spa_packet_age_seconds"></a>`max_spa_packet_age_seconds`

Data type: `Optional[Integer]`

Defines the maximum age (in seconds) that an SPA packet will be
accepted. This requires that the client system is in relatively
close time synchronization with the fwknopd server system (NTP is
good). The default age is two minutes.

Default value: `undef`

##### <a name="-fwknop--enable_digest_persistence"></a>`enable_digest_persistence`

Data type: `Optional[Boolean]`

Track digest sums associated with previous fwknop process. This
allows digest sums to remain persistent across executions of fwknop.

Default value: `undef`

##### <a name="-fwknop--rules_check_threshold"></a>`rules_check_threshold`

Data type: `Optional[Integer]`

Defines the number of times firewall rule expiration times must be
checked before a "deep" check is run. This allows fwknopd to remove
rules that contain a proper exp<time> even if a third party program
added them instead of fwknopd. The default value for this variable
is 20, and this typically results in this check being run every two
seconds or so. To disable this type of checking altogether, set this
variable to zero.

Default value: `undef`

##### <a name="-fwknop--enable_ipt_forwarding"></a>`enable_ipt_forwarding`

Data type: `Optional[Boolean]`

Allow SPA clients to request access to services through an
iptables firewall instead of just to it (i.e. access through
the FWKNOP_FORWARD chain instead of the INPUT chain).

Default value: `undef`

##### <a name="-fwknop--enable_ipt_local_nat"></a>`enable_ipt_local_nat`

Data type: `Optional[Boolean]`

Allow SPA clients to request access to a local socket via NAT.
This still puts an ACCEPT rule into the FWKNOP_INPUT chain, but a
different port is translated via DNAT rules to the real one. So, the
user would do "ssh -p <port>" to access the local service (see the
--NAT-local and --NAT-rand-port on the fwknop client command line).

Default value: `undef`

##### <a name="-fwknop--enable_ipt_snat"></a>`enable_ipt_snat`

Data type: `Optional[Boolean]`

By default, if forwarding access is enabled (see the
enable_ipt_forwarding parameter), then fwknop creates DNAT rules for
incoming connections, but does not also complement these rules with
SNAT rules at the same time. In some situations, internal systems
may not have a route back out for the source address of the incoming
connection, so it is necessary to also apply SNAT rules so that the
internal systems see the IP of the internal interface where fwknopd
is running. This functionality is only enabled when enable_ipt_snat
is set to true, and by default SNAT rules are built with the
MASQUERADE target (since then the internal IP does not have to be
defined here in the fwknop.conf file), but if you want fwknopd to
use the SNAT target then also define an IP address with the
snat_translate_ip parameter.

Default value: `undef`

##### <a name="-fwknop--snat_translate_ip"></a>`snat_translate_ip`

Data type: `Optional[String]`

The IP address to use when enable_ipt_snat is true.

Default value: `undef`

##### <a name="-fwknop--enable_ipt_output"></a>`enable_ipt_output`

Data type: `Optional[Boolean]`

Add ACCEPT rules to the FWKNOP_OUTPUT chain. This is usually only
useful if there are no state tracking rules to allow connection
responses out and the OUTPUT chain has a default-drop stance.

Default value: `undef`

##### <a name="-fwknop--max_sniff_bytes"></a>`max_sniff_bytes`

Data type: `Optional[Integer]`

Specify the the maximum number of bytes to sniff per frame - 1500 is
a good default

Default value: `undef`

##### <a name="-fwknop--flush_ipt_at_init"></a>`flush_ipt_at_init`

Data type: `Optional[Boolean]`

Flush all existing rules in the fwknop chains at fwknop start time.
Defaults to true and it is a recommended setting.

Default value: `undef`

##### <a name="-fwknop--flush_ipt_at_exit"></a>`flush_ipt_at_exit`

Data type: `Optional[Boolean]`

Flush all existing rules in the fwknop chains at fwknop exit time.
Defaults to true and it is a recommended setting.

Default value: `undef`

##### <a name="-fwknop--exit_at_intf_down"></a>`exit_at_intf_down`

Data type: `Optional[Boolean]`

When fwknopd is sniffing an interface, if the interface is
administratively downed or unplugged, fwknopd will cleanly exit and
an assumption is made that any process monitoring infrastructure
like systemd or upstart will restart it. However, if fwknopd is not
being monitored by systemd, upstart, or anything else, this behavior
can be disabled with the exit_at_intf_down parameter. If disabled,
fwknopd will try to recover when a downed interface comes back up.

Default value: `undef`

##### <a name="-fwknop--enable_rule_prepend"></a>`enable_rule_prepend`

Data type: `Optional[Boolean]`

Instead of appending new firewall rules to the bottom of the chain,
this option inserts rules at the top of the chain. This causes newly
created rules to have precedence over older ones.

Default value: `undef`

##### <a name="-fwknop--enable_nat_dns"></a>`enable_nat_dns`

Data type: `Optional[Boolean]`

Allow fwknopd to resolve hostnames in NAT access messages.

Default value: `undef`

##### <a name="-fwknop--gpg_home_dir"></a>`gpg_home_dir`

Data type: `Optional[String]`

If GPG keys are used instead of a Rijndael symmetric key, this is
the default GPG keys directory. Note that each access stanza in
fwknop access.conf can specify its own GPG directory to override
this default.

Default value: `undef`

##### <a name="-fwknop--gpg_exe"></a>`gpg_exe`

Data type: `Optional[String]`

Set the default GPG path when GPG is used for SPA encryption
and authentication.

Default value: `undef`

##### <a name="-fwknop--locale"></a>`locale`

Data type: `Optional[String]`

Set/override the locale (via the LC_ALL locale category). Leave this
entry undefined to have fwknopd honor the default system locale.

Default value: `undef`

##### <a name="-fwknop--enable_spa_over_http"></a>`enable_spa_over_http`

Data type: `Optional[Boolean]`

Allow fwknopd to acquire SPA data from HTTP requests (generated with
the fwknop client in --HTTP mode). Note that the pcap_filter
parameter would need to be updated when this is enabled to sniff
traffic over TCP/80 connections.

Default value: `undef`

##### <a name="-fwknop--enable_x_forwarded_for"></a>`enable_x_forwarded_for`

Data type: `Optional[Boolean]`

Allows the use of the X-Forwarded-for header from a captured
packet as the Source IP. This can happen when using SPA through
an HTTP proxy.

Default value: `undef`

##### <a name="-fwknop--enable_tcp_server"></a>`enable_tcp_server`

Data type: `Optional[Boolean]`

Enable the fwknopd TCP server. This is a "dummy" TCP server that
will accept TCP connection requests on the specified tcpserv_port.
If set to true, fwknopd will fork off a child process to listen for
and accept incoming TCP requests. This server only accepts the
request. It does not otherwise communicate. This is only to allow
the incoming SPA over TCP packet which is detected via PCAP. The
connection is closed after 1 second regardless. Note that fwknopd
still only gets its data via pcap, so the filter defined by
pcap_filter needs to be updated to include this TCP port.

Default value: `undef`

##### <a name="-fwknop--tcpserv_port"></a>`tcpserv_port`

Data type: `Optional[Integer]`

The port for the TCP server if enable_tcp_server is true.

Default value: `undef`

##### <a name="-fwknop--enable_udp_server"></a>`enable_udp_server`

Data type: `Optional[Boolean]`

This is probably similar to enable_tcp_server but UDP.

Default value: `undef`

##### <a name="-fwknop--udpserv_port"></a>`udpserv_port`

Data type: `Optional[Integer]`

The port for the UDP server if enable_udp_server is true.

Default value: `undef`

##### <a name="-fwknop--pcap_dispatch_count"></a>`pcap_dispatch_count`

Data type: `Optional[Integer]`

Sets the number of packets that are processed when the
pcap_dispatch() call is made. The default is zero, since this allows
fwknopd to process as many packets as possible in the corresponding
callback where the SPA handling routine is called for packets that
pass a set of prerequisite checks. However, if fwknopd is running on
a platform with an old version of libpcap, it may be necessary to
change this value to a positive non-zero integer. More information
can be found in the pcap_dispatch(3) man page.

Default value: `undef`

##### <a name="-fwknop--pcap_loop_sleep_microseconds"></a>`pcap_loop_sleep_microseconds`

Data type: `Optional[Integer]`

Sets the number of microseconds to pass as an argument to usleep()
in the pcap loop. The default is 100000 microseconds, or 1/10th of
a second.

Default value: `undef`

##### <a name="-fwknop--enable_pcap_any_direction"></a>`enable_pcap_any_direction`

Data type: `Optional[Boolean]`

This parameter controls whether fwknopd is permitted to sniff SPA
packets regardless of whether they are received on the sniffing
interface or sent from the sniffing interface. In the latter case,
this can be useful to have fwknopd sniff SPA packets that are
forwarded through a system and destined for a different network. If
the sniffing interface is the egress interface for such packets,
then this parameter will need to be set to true in order for fwknopd
to see them. The default is false so that fwknopd only looks for SPA
packets that are received on the sniffing interface (note that this
is independent of promiscuous mode).

Default value: `undef`

##### <a name="-fwknop--syslog_identity"></a>`syslog_identity`

Data type: `Optional[String]`

Override syslog identity (the defaults are usually ok).

Default value: `undef`

##### <a name="-fwknop--syslog_facility"></a>`syslog_facility`

Data type: `Optional[String]`

Override syslog facility (the defaults are usually ok). The
syslog_facility parameter can be set to one of LOG_LOCAL{0-7} or
LOG_DAEMON (the default).

Default value: `undef`

##### <a name="-fwknop--enable_destination_rule"></a>`enable_destination_rule`

Data type: `Optional[Boolean]`

Controls whether fwknopd will set the destination field on the
firewall rule to the destination address specified on the incoming
SPA packet. This is useful for interfaces with multiple IP addresses
hosting separate services. If enable_ipt_output is set to true, the
source field of the firewall rule is set. FORWARD and SNAT rules are
not affected however, DNAT rules will also have their destination
field set. The default is false, which sets the destination field
to 0.0.0.0/0 (any).

Default value: `undef`

##### <a name="-fwknop--fwknop_run_dir"></a>`fwknop_run_dir`

Data type: `Optional[String]`

Defaults to /var/run/fwknop

Default value: `undef`

##### <a name="-fwknop--verbose"></a>`verbose`

Data type: `Optional[Integer]`

Define the default verbosity level the fwknop server should use. A
value of 0 is the default verbosity level. Setting it up to 1 or
higher will allow debugging messages to be displayed.

Default value: `undef`

##### <a name="-fwknop--package_manage"></a>`package_manage`

Data type: `Boolean`

Whether to manage the fwknop-server package. Default true.

Default value: `true`

##### <a name="-fwknop--service_manage"></a>`service_manage`

Data type: `Boolean`

Whether to manage the fwknop-server service. Default true.

Default value: `true`

## Defined types

### <a name="fwknop--access"></a>`fwknop::access`

fwknop::access

Add a stanza to fwknop's access.conf file.

#### Examples

##### 

```puppet
fwknop::access { 'example':
  source                 => 'ANY',
  require_source_address => true,
  key_base64             => Sensitive('Sz80RjpXOlhH2olGuKBUamHKcqyMBsS9BTgLaMugUsg='),
  hmac_key_base64        => Sensitive('c0TOaMJ2aVPdYTh4Aa25Dwxni7PrLo2zLAtBoVwSepkvH6nLcW45Cjb9zaEC2SQd03kaaV+Ckx3FhCh5ohNM5Q=='),
}
```

#### Parameters

The following parameters are available in the `fwknop::access` defined type:

* [`source`](#-fwknop--access--source)
* [`destination`](#-fwknop--access--destination)
* [`open_ports`](#-fwknop--access--open_ports)
* [`restrict_ports`](#-fwknop--access--restrict_ports)
* [`key`](#-fwknop--access--key)
* [`key_base64`](#-fwknop--access--key_base64)
* [`hmac_key`](#-fwknop--access--hmac_key)
* [`hmac_key_base64`](#-fwknop--access--hmac_key_base64)
* [`fw_access_timeout_seconds`](#-fwknop--access--fw_access_timeout_seconds)
* [`include`](#-fwknop--access--include)
* [`include_folder`](#-fwknop--access--include_folder)
* [`encryption_mode`](#-fwknop--access--encryption_mode)
* [`hmac_digest_type`](#-fwknop--access--hmac_digest_type)
* [`access_expire`](#-fwknop--access--access_expire)
* [`access_expire_epoch`](#-fwknop--access--access_expire_epoch)
* [`enable_cmd_exec`](#-fwknop--access--enable_cmd_exec)
* [`cmd_exec_user`](#-fwknop--access--cmd_exec_user)
* [`enable_cmd_sudo_exec`](#-fwknop--access--enable_cmd_sudo_exec)
* [`cmd_sudo_exec_user`](#-fwknop--access--cmd_sudo_exec_user)
* [`cmd_exec_group`](#-fwknop--access--cmd_exec_group)
* [`cmd_sudo_exec_group`](#-fwknop--access--cmd_sudo_exec_group)
* [`cmd_cycle_open`](#-fwknop--access--cmd_cycle_open)
* [`cmd_cycle_close`](#-fwknop--access--cmd_cycle_close)
* [`cmd_cycle_timer_seconds`](#-fwknop--access--cmd_cycle_timer_seconds)
* [`sudo_exe`](#-fwknop--access--sudo_exe)
* [`require_username`](#-fwknop--access--require_username)
* [`require_source_address`](#-fwknop--access--require_source_address)
* [`force_nat`](#-fwknop--access--force_nat)
* [`force_snat`](#-fwknop--access--force_snat)
* [`force_masquerade`](#-fwknop--access--force_masquerade)
* [`forward_all`](#-fwknop--access--forward_all)
* [`disable_dnat`](#-fwknop--access--disable_dnat)
* [`gpg_decrypt_id`](#-fwknop--access--gpg_decrypt_id)
* [`gpg_decrypt_pw`](#-fwknop--access--gpg_decrypt_pw)
* [`gpg_allow_no_pw`](#-fwknop--access--gpg_allow_no_pw)
* [`gpg_require_sig`](#-fwknop--access--gpg_require_sig)
* [`gpg_disable_sig`](#-fwknop--access--gpg_disable_sig)
* [`gpg_ignore_sig_verify_error`](#-fwknop--access--gpg_ignore_sig_verify_error)
* [`gpg_remote_id`](#-fwknop--access--gpg_remote_id)
* [`gpg_fingerprint_id`](#-fwknop--access--gpg_fingerprint_id)
* [`gpg_home_dir`](#-fwknop--access--gpg_home_dir)
* [`gpg_exe`](#-fwknop--access--gpg_exe)
* [`order`](#-fwknop--access--order)

##### <a name="-fwknop--access--source"></a>`source`

Data type: `String`

This defines the source address from which a SPA packet will be
accepted. Every authorization stanza in this file must start with
the SOURCE keyword. Networks should be specified in CIDR (e.g.
"192.168.10.0/24") notation. Individual IP addresses can be
specified as well.

Also, multiple IP's and/or networks can be defined as a
comma-separated list (e.g. "192.168.10.0/24,10.1.1.123").

The string "ANY" is also accepted if a valid authorization packet
should be honored from any source IP.

Default value: `'ANY'`

##### <a name="-fwknop--access--destination"></a>`destination`

Data type: `Optional[String]`

This defines the destination address for which a SPA packet
will be accepted. Networks should be specified in CIDR (e.g.
"192.168.10.0/24") notation. Individual IP addresses can be
specified as well.

Also, multiple IP's and/or networks can be defined as a
comma-separated list (e.g. "192.168.10.0/24,10.1.1.123").

The string "ANY" is also accepted if a valid authorization packet
should be honored to any destination IP.

Default value: `undef`

##### <a name="-fwknop--access--open_ports"></a>`open_ports`

Data type: `Optional[String]`

Define a set of ports and protocols (tcp or udp) that are allowed to
be opened if a valid SPA packet is received and its access request
matches one of the entries here.

If this entry is not set, then fwknopd will attempt to honor the
request specified in the SPA data.

Default value: `undef`

##### <a name="-fwknop--access--restrict_ports"></a>`restrict_ports`

Data type: `Optional[String]`

Define a set of ports and protocols (tcp or udp) that are *NOT*
allowed to be opened even if a valid SPA packet is received.

Default value: `undef`

##### <a name="-fwknop--access--key"></a>`key`

Data type: `Optional[Variant[String, Sensitive[String]]]`

Define the key used for decrypting an incoming SPA packet that is
using its built-in encryption (e.g. not GPG). This parameter is
required for all non-GPG-encrypted SPA packets.

Default value: `undef`

##### <a name="-fwknop--access--key_base64"></a>`key_base64`

Data type: `Optional[Variant[String, Sensitive[String]]]`

Same as the key parameter, but specify the symmetric key as a base64
encoded string. This allows non-ascii characters to be included in
the base64-decoded key.

Default value: `undef`

##### <a name="-fwknop--access--hmac_key"></a>`hmac_key`

Data type: `Optional[Variant[String, Sensitive[String]]]`

Specify the HMAC key for authenticated encryption of SPA packets.
This supports both Rijndael and GPG encryption modes, and is applied
according to the encrypt-then-authenticate model.

Default value: `undef`

##### <a name="-fwknop--access--hmac_key_base64"></a>`hmac_key_base64`

Data type: `Optional[Variant[String, Sensitive[String]]]`

Specify the HMAC key as a base64 encoded string. This allows
non-ascii characters to be included in the base64-decoded key.

Default value: `undef`

##### <a name="-fwknop--access--fw_access_timeout_seconds"></a>`fw_access_timeout_seconds`

Data type: `Optional[Integer]`

Define the length of time access will be granted by fwknop through
the firewall after a valid SPA packet is received from the source IP
address that matches this stanza's source.

If fw_access_timeout is not set then a default timeout of 30 seconds
will automatically be set.

Default value: `undef`

##### <a name="-fwknop--access--include"></a>`include`

Data type: `Optional[String]`

This processes the access.conf stanzas from an additional file.
Complete stanzas should be contained within each file.

Default value: `undef`

##### <a name="-fwknop--access--include_folder"></a>`include_folder`

Data type: `Optional[String]`

This processes all the *.conf files in the specified directory.

Default value: `undef`

##### <a name="-fwknop--access--encryption_mode"></a>`encryption_mode`

Data type: `Optional[String]`

Specify the encryption mode when AES is used. The default is CBC
mode, but other modes can be selected such as OFB and CFB. In
general, it is recommended to not use this parameter and leave it
as the default. Note that the string "legacy" can be specified in
order to generate SPA packets with the old initialization vector
strategy used by versions of fwknop before 2.5. With the 2.5
release, fwknop uses PBKDF1 for key derivation.

Default value: `undef`

##### <a name="-fwknop--access--hmac_digest_type"></a>`hmac_digest_type`

Data type: `Optional[String]`

Specify the digest algorithm for incoming SPA packet authentication.
Must be one of MD5, SHA1, SHA256, SHA384, SHA512, SHA3_256, or
SHA3_512. This is an optional field, and if not specified then
fwknopd defaults to using SHA256 if the access stanza requires an
HMAC.

Default value: `undef`

##### <a name="-fwknop--access--access_expire"></a>`access_expire`

Data type: `Optional[String]`

Defines an expiration date for the access stanza in MM/DD/YYYY
format. All SPA packets that match an expired stanza will be
ignored. This parameter is optional.

Default value: `undef`

##### <a name="-fwknop--access--access_expire_epoch"></a>`access_expire_epoch`

Data type: `Optional[Integer]`

Defines an expiration date for the access stanza as the epoch time,
and is useful if a more accurate expiration time needs to be given
than the day resolution offered by the access_expire parameter
above. All SPA packets that match an expired stanza will be ignored.
This parameter is optional.

Default value: `undef`

##### <a name="-fwknop--access--enable_cmd_exec"></a>`enable_cmd_exec`

Data type: `Optional[Boolean]`

This specifies whether or not fwknopd will accept complete commands
that are contained within a SPA packet. Any such command will be
executed as user specified using the cmd_exec_user parameter by the
fwknopd server. If not set here, the default is false.

Default value: `undef`

##### <a name="-fwknop--access--cmd_exec_user"></a>`cmd_exec_user`

Data type: `Optional[String]`

This specifies the user that will execute commands contained within
a SPA packet. If not specified, fwknopd will execute it as the user
it is running as (most likely root). Setting this to a non-root user
is highly recommended.

Default value: `undef`

##### <a name="-fwknop--access--enable_cmd_sudo_exec"></a>`enable_cmd_sudo_exec`

Data type: `Optional[Boolean]`

sudo provides a powerful means of restricting the sets of commands
that users can execute via the "sudoers" file. By enabling this
feature (and in "enable_cmd_exec" mode), all incoming commands from
valid SPA packets will be prefixed by "/path/to/sudo -u <user> -g
<group>" where the path to sudo is set by the "sudo_exe" parameter,
"<user>" is set by the "cmd_sudo_exec_user" parameter (default is
"root" if not set), and "<group>" is set by "cmd_sudo_exec_group"
(default is also "root" if not set).

Default value: `undef`

##### <a name="-fwknop--access--cmd_sudo_exec_user"></a>`cmd_sudo_exec_user`

Data type: `Optional[String]`

Specify the user (via "sudo -u <user>") that will execute a command
contained within a SPA packet. If this parameter is not given,
fwknopd will assume the command should be executed as root.

Default value: `undef`

##### <a name="-fwknop--access--cmd_exec_group"></a>`cmd_exec_group`

Data type: `Optional[String]`

Specify the group (via setgid) that will execute a command contained
within a SPA packet. If this parameter is not given, fwknopd will
execute the command as the user it is running as (most likely root).
Setting this to a non-root user such as "nobody" is highly
recommended if elevated permissions are not needed.

Default value: `undef`

##### <a name="-fwknop--access--cmd_sudo_exec_group"></a>`cmd_sudo_exec_group`

Data type: `Optional[String]`

Specify the group (via "sudo -g <group>") that will execute a
command contained within a SPA packet. If this parameter is not
given, fwknopd will assume the command should be executed as root.

Default value: `undef`

##### <a name="-fwknop--access--cmd_cycle_open"></a>`cmd_cycle_open`

Data type: `Optional[String]`

Specify a command open/close cycle to be executed upon receipt of a
valid SPA packet. This directive sets the initial command, and is
meant to be used in conjunction with the "cmd_cycle_close" parameter
below. The main application of this feature is to allow fwknopd to
interact with firewall or ACL's that are not natively supported, and
facilitate the same access model as for the main supported firewalls
such as iptables. That is, a command is executed to open the
firewall or ACL, and then a corresponding close command is executed
after a timer expires. Both the "cmd_cycle_open" and
"cmd_cycle_close" parameters support special substitution strings to
allow values to be taken from the SPA payload and used on the
command line of the executed command. These strings begin with a "$"
character, and include "$IP" (the allow IP decrypted from the SPA
payload), "$SRC" (synonym for "$IP") , "$PKT_SRC" (the source IP in
the network layer header of the SPA packet), "$DST" (the destination
IP), "$PORT" (the allow port), and "$PROTO" (the allow protocol),
"$TIMEOUT" (set the client timeout if specified).

Default value: `undef`

##### <a name="-fwknop--access--cmd_cycle_close"></a>`cmd_cycle_close`

Data type: `Optional[String]`

Specify the close command that corresponds to the open command set
by the "cmd_cycle_open" parameter. The same string substitutions
such as "$IP", "$PORT", and "$PROTO" are supported. In addition, the
special value "NONE" can be set to allow no close command to be
executed after the open command. This might be handy in certain
situations where, say, indefinite access is desired and allowed.

Default value: `undef`

##### <a name="-fwknop--access--cmd_cycle_timer_seconds"></a>`cmd_cycle_timer_seconds`

Data type: `Optional[Integer]`

Set the number of seconds after which the close command set in
"cmd_cycle_close" will be executed. This defines the open/close
timer interval.

Default value: `undef`

##### <a name="-fwknop--access--sudo_exe"></a>`sudo_exe`

Data type: `Optional[String]`

Define the path to the sudo binary. Default is "/usr/bin/sudo".

Default value: `undef`

##### <a name="-fwknop--access--require_username"></a>`require_username`

Data type: `Optional[String]`

Require a specific username from the client system as encoded in the
SPA data. This parameter is optional and if not specified, the
username data in the SPA data is ignored.

Default value: `undef`

##### <a name="-fwknop--access--require_source_address"></a>`require_source_address`

Data type: `Optional[Boolean]`

Force all SPA packets to contain a real IP address within the
encrypted data. This makes it impossible to use the "-s" command
line argument on the fwknop client command line, so either "-R" has
to be used to automatically resolve the external address (if the
client is behind a NAT) or the client must know the external IP. If
not set here, the default is false.

Default value: `undef`

##### <a name="-fwknop--access--force_nat"></a>`force_nat`

Data type: `Optional[String]`

For any valid SPA packet, force the requested connection to be NAT'd
through to the specified (usually internal) IP and port value. This
is useful if there are multiple internal systems running a service
such as SSHD, and you want to give transparent access to only one
internal system for each stanza in the access.conf file. This way,
multiple external users can each directly access only one internal
system per SPA key.

Default value: `undef`

##### <a name="-fwknop--access--force_snat"></a>`force_snat`

Data type: `Optional[String]`

For any valid SPA packet, add an SNAT rule in addition to any DNAT
rule created with a corresponding (required) force_nat parameter.
This is analogous to the "fwknop::snat_translate_ip" parameter
except that it is per access stanza and overrides any value set with
"fwknop::snat_translate_ip". This is useful for situations where an
incoming NAT'd connection may be otherwise unanswerable due to
routing constraints (i.e. the system receiving the SPA authenticated
connection has a default route to a different device than the SPA
system itself).

Default value: `undef`

##### <a name="-fwknop--access--force_masquerade"></a>`force_masquerade`

Data type: `Optional[Boolean]`

This is similar to the "force_snat" parameter, except that it is not
necessary to also specify an IP address for SNAT rules because the
MASQUERADE target is used instead.

Default value: `undef`

##### <a name="-fwknop--access--forward_all"></a>`forward_all`

Data type: `Optional[Boolean]`

In NAT scenarios, control whether all traffic is forwarded through
the fwknopd system as opposed to just forwarding connections to
specific services as requested by the fwknop client.

Default value: `undef`

##### <a name="-fwknop--access--disable_dnat"></a>`disable_dnat`

Data type: `Optional[Boolean]`

Control whether DNAT rules are created in force_nat scenarios. This
is mainly used in conjunction with the forward_all parameter to
allow fwknopd to act essentially as an SPA gateway. I.e., the fwknop
client is used to gain access via SPA to the broader Internet after
being granted an IP via DHCP, but prior to sending the SPA packet
all traffic is blocked by default to the Internet.

Default value: `undef`

##### <a name="-fwknop--access--gpg_decrypt_id"></a>`gpg_decrypt_id`

Data type: `Optional[String]`

Define a GnuPG key ID to use for decrypting SPA messages that have
been encrypted by an fwknop client using GPG. This keyword is
required for authentication that is based on gpg keys. The gpg key
ring on the client must have imported and signed the fwknopd server
key, and vice versa.

It is ok to use a sensitive personal gpg key on the client, but each
fwknopd server should have its own gpg key that is generated
specifically for fwknop communications. The reason for this is that
this decryption password within this file.

Note that you can use either keyID or its corresponding email address.

For more information on using fwknop with GnuPG keys, see the
following link: http://www.cipherdyne.org/fwknop/docs/gpghowto.html

Default value: `undef`

##### <a name="-fwknop--access--gpg_decrypt_pw"></a>`gpg_decrypt_pw`

Data type: `Optional[Variant[String, Sensitive[String]]]`

Specify the decryption password for the gpg key defined by the
gpg_decrypt_id parameter. This is a required field for gpg-based
authentication.

Default value: `undef`

##### <a name="-fwknop--access--gpg_allow_no_pw"></a>`gpg_allow_no_pw`

Data type: `Optional[Boolean]`

Allow fwknopd to leverage a GnuPG key pair that does not have an
associated password. While this may sound like a controversial
deployment mode, in automated environments it makes sense because
"there is usually no way to store a password more securely than on
the secret keyring itself" according to:
"http://www.gnupg.org/faq/GnuPG-FAQ.html#how-can-i-use-gnupg-in-an-automated-environment".
Using this feature and removing the passphrase from a GnuPG key pair
is useful in some environments where libgpgme is forced to use
gpg-agent and/or pinentry to collect a passphrase.

Default value: `undef`

##### <a name="-fwknop--access--gpg_require_sig"></a>`gpg_require_sig`

Data type: `Optional[Boolean]`

With this setting set to true, fwknopd check all GPG-encrypted SPA
messages for a signature (signed by the sender's key). If the
incoming message is not signed, the decryption process will fail.
If not set, the default is false.

Default value: `undef`

##### <a name="-fwknop--access--gpg_disable_sig"></a>`gpg_disable_sig`

Data type: `Optional[Boolean]`

Disable signature verification for incoming SPA messages. This is
not a recommended setting, and the default is false.

Default value: `undef`

##### <a name="-fwknop--access--gpg_ignore_sig_verify_error"></a>`gpg_ignore_sig_verify_error`

Data type: `Optional[Boolean]`

Setting this will allow fwknopd to accept incoming GPG-encrypted
packets that are signed, but the signature did not pass verification
(i.e. the signer key was expired, etc.). This setting only applies
if the gpg_require_sig parameter is also set to true.

Default value: `undef`

##### <a name="-fwknop--access--gpg_remote_id"></a>`gpg_remote_id`

Data type: `Optional[String]`

Define a list of gpg key ID's that are required to have signed any
incoming SPA messages that have been encrypted with the fwknopd
server key. This ensures that the verification of the remote user
is accomplished via a strong cryptographic mechanism. This setting
only applies if the gpg_require_sig is set to true.

Default value: `undef`

##### <a name="-fwknop--access--gpg_fingerprint_id"></a>`gpg_fingerprint_id`

Data type: `Optional[String]`

Specify a set of full-length GnuPG key fingerprints instead of the
shorter key identifiers set with the "gpg_remote_id" parameter. Here
is an example fingerprint for one of the fwknop test suite keys:
00CC95F05BC146B6AC4038C9E36F443C6A3FAD56.

Default value: `undef`

##### <a name="-fwknop--access--gpg_home_dir"></a>`gpg_home_dir`

Data type: `Optional[String]`

Define the path to the GnuPG directory to be used by fwknopd. If
this keyword is not specified here, then fwknopd will default to
using the "/root/.gnupg" directory for the server key(s).

Default value: `undef`

##### <a name="-fwknop--access--gpg_exe"></a>`gpg_exe`

Data type: `Optional[String]`

Define the path to the GnuPG executable. If this keyword is not
specified then fwknopd will default to using /usr/bin/gpg.

Default value: `undef`

##### <a name="-fwknop--access--order"></a>`order`

Data type: `Variant[String, Integer]`

Reorders your access stanzas within the access.conf. Stanzas that
share the same order number are ordered by name. Default is '10'.

Default value: `'10'`

